#!/bin/bash

set -e

ELDF=${EPIPHANY_HOME}/bsps/zed_E16G3_512mb/internal.ldf
INCD=${EPIPHANY_HOME}/tools/host/include
LDDR=${EPIPHANY_HOME}/tools/host/lib

echo "Building device code..."
e-gcc -O3 -T${ELDF} -D__DEVICE__ sync_epi.c -o sync_epi.elf -le-lib
e-objcopy --srec-forceS3 --output-target srec sync_epi.elf sync.srec
rm sync_epi.elf

echo "Building host code..."
gcc -O3 -I${INCD} -L${LDDR} -D__HOST__ sync_arm.c -o sync.elf -le-hal --std=c99
