#pragma once

#include <sys/types.h>

#ifdef __DEVICE__
extern const unsigned int _SHARED_DRAM_;
#define SHARED_DRAM ((unsigned int)&_SHARED_DRAM_)
#define DRAM_PTR(off) ((void*)(SHARED_DRAM + (off)))
#endif

typedef struct Mailbox
{
	int go;
	int done;
	off_t core_done;
#ifdef __DEVICE__
	e_mutex_t* mutex;
#else
	void* mutex;
#endif
	int counter;
} mailbox_t;
