#include <stdio.h>
#include <stdlib.h>
#include <e_hal.h>
#include <stddef.h>
#include "sync.h"

int main(int argc, char* argv[])
{
	int r = 4, c = 4;
	e_mem_t emem;
	e_epiphany_t epi;

	e_init(NULL);
	e_alloc(&emem, 0x00000000, 0x00400000);

	// Initialize mailbox
	mailbox_t mailbox;
	mailbox.go = 0;
	mailbox.done = 0;
	mailbox.core_done = sizeof(mailbox_t);
	mailbox.counter = 0;
	e_write(&emem, 0, 0, 0x00000000, &mailbox, sizeof(mailbox));
	
	// Start the program
	e_open(&epi, 0, 0, r, c);
	e_reset_system();
	e_load_group("sync.srec", &epi, 0, 0, r, c, e_true);

	// Wait until the program is finished, then display final counter value
	do
	{
		e_read(&emem, 0, 0, offsetof(mailbox_t, done), &mailbox.done, sizeof(int));
	} while (mailbox.done == 0);
	e_read(&emem, 0, 0, offsetof(mailbox_t, counter), &mailbox.counter, sizeof(int));
	printf("Final counter value: %d\n", mailbox.counter);

	e_close(&epi);
	e_free(&emem);
	e_finalize();
	return 0;
}
